// CodeWarClientView.cpp : implementation of the CCodeWarClientView class
//

#include "stdafx.h"
#include "CodeWarClient.h"

#include "CodeWarClientDoc.h"
#include "CodeWarClientView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

#include "../CodeWarCommon/CodeWarCommands.h"

const UINT TimerID = 1234;
const UINT TimerTime = 20;

// CCodeWarClientView

IMPLEMENT_DYNCREATE(CCodeWarClientView, CFormView)

BEGIN_MESSAGE_MAP(CCodeWarClientView, CFormView)
    ON_BN_CLICKED(IDC_CONNECT_BTN, OnBnClickedConnectBtn)
    ON_BN_CLICKED(IDC_FORWARD_BTN, OnBnClickedForwardBtn)
    ON_BN_CLICKED(IDC_BACK_BTN, OnBnClickedBackBtn)
    ON_BN_CLICKED(IDC_TURN_LEFT_BTN, OnBnClickedTurnLeftBtn)
    ON_BN_CLICKED(IDC_TURN_RIGHT_BTN, OnBnClickedTurnRightBtn)
    ON_WM_TIMER()
    ON_BN_CLICKED(IDC_FIGHT_BTN, OnBnClickedFightBtn)
    ON_BN_CLICKED(IDC_ACT_STUPID_CHK, OnBnClickedActStupidChk)
    ON_BN_CLICKED(IDC_EAT_BTN, OnBnClickedEatBtn)
    ON_BN_CLICKED(IDC_REST_BTN, OnBnClickedRestBtn)
END_MESSAGE_MAP()

// CCodeWarClientView construction/destruction

CCodeWarClientView::CCodeWarClientView()
	: CFormView(CCodeWarClientView::IDD)
    , m_Port(1234)
    , m_Status(_T("Not connected"))
    , m_Life(_T(""))
    , m_Food(_T(""))
    , m_Attacked(_T(""))
    , m_actStupid(FALSE)
{
	// TODO: add construction code here

}

CCodeWarClientView::~CCodeWarClientView()
{
}

void CCodeWarClientView::DoDataExchange(CDataExchange* pDX)
{
    CFormView::DoDataExchange(pDX);
    DDX_Text(pDX, IDC_PORT, m_Port);
    DDX_Text(pDX, IDC_STATUS, m_Status);
    DDX_Text(pDX, IDC_LIFE, m_Life);
    DDX_Text(pDX, IDC_FOOD, m_Food);
    DDX_Text(pDX, IDC_ATTACKED, m_Attacked);
    DDX_Check(pDX, IDC_ACT_STUPID_CHK, m_actStupid);
}

BOOL CCodeWarClientView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CFormView::PreCreateWindow(cs);
}

void CCodeWarClientView::OnInitialUpdate()
{
	CFormView::OnInitialUpdate();
	GetParentFrame()->RecalcLayout();
	ResizeParentToFit();

    SetTimer( TimerID, TimerTime, NULL );
}


// CCodeWarClientView diagnostics

#ifdef _DEBUG
void CCodeWarClientView::AssertValid() const
{
	CFormView::AssertValid();
}

void CCodeWarClientView::Dump(CDumpContext& dc) const
{
	CFormView::Dump(dc);
}

CCodeWarClientDoc* CCodeWarClientView::GetDocument() const // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CCodeWarClientDoc)));
	return (CCodeWarClientDoc*)m_pDocument;
}
#endif //_DEBUG


// CCodeWarClientView message handlers

void CCodeWarClientView::OnBnClickedConnectBtn()
{
    // TODO: Add your control notification handler code here
    UpdateData( TRUE );

    if( theApp.m_Robot.initialize( m_Port ) )
    {
        m_Status = "Connected";
    }
    else
    {
        m_Status = "Not connected";
    }

    UpdateData( FALSE );
}

void CCodeWarClientView::OnBnClickedForwardBtn()
{
    // TODO: Add your control notification handler code here
    KillTimer( TimerID );

    theApp.m_Robot.moveForward();

    SetTimer( TimerID, TimerTime, NULL );
}

void CCodeWarClientView::OnBnClickedBackBtn()
{
    // TODO: Add your control notification handler code here
    KillTimer( TimerID );

    theApp.m_Robot.moveBackward();

    SetTimer( TimerID, TimerTime, NULL );
}

void CCodeWarClientView::OnBnClickedTurnLeftBtn()
{
    // TODO: Add your control notification handler code here
    KillTimer( TimerID );

    theApp.m_Robot.turnLeft();

    SetTimer( TimerID, TimerTime, NULL );
}

void CCodeWarClientView::OnBnClickedTurnRightBtn()
{
    // TODO: Add your control notification handler code here
    KillTimer( TimerID );

    theApp.m_Robot.turnRight();

    SetTimer( TimerID, TimerTime, NULL );
}

void CCodeWarClientView::OnTimer(UINT nIDEvent)
{
    // TODO: Add your message handler code here and/or call default
    switch( nIDEvent )
    {
    case TimerID:
        KillTimer( TimerID );
        UpdateScreen();
        SetTimer( TimerID, TimerTime, NULL );
        break;
    }

    CFormView::OnTimer(nIDEvent);
}

void CCodeWarClientView::OnBnClickedFightBtn()
{
    // TODO: Add your control notification handler code here
    KillTimer( TimerID );

    theApp.m_Robot.fight();

    SetTimer( TimerID, TimerTime, NULL );
}

void CCodeWarClientView::UpdateScreen(void)
{
    static int attacks = 0;

    if( theApp.m_Robot.connected() )
    {
        m_Status = "Connected";
    }
    else
    {
        m_Status = "Not connected";
    }

    FoodType food = theApp.m_Robot.getFoodStatus();
    m_Food.Format("%d", food);

    LifeType life = theApp.m_Robot.getLifeStatus();
    m_Life.Format("%d", life);

    if( theApp.m_Robot.attacked() )
    {
        ++attacks;
    }
    m_Attacked.Format("%d", attacks);

    UpdateData( FALSE );
}

void CCodeWarClientView::OnBnClickedActStupidChk()
{
    UpdateData( TRUE );

    theApp.m_Robot.actStupid( (bool)m_actStupid );
}

void CCodeWarClientView::OnBnClickedEatBtn()
{
    KillTimer( TimerID );

    theApp.m_Robot.eat();

    SetTimer( TimerID, TimerTime, NULL );
}

void CCodeWarClientView::OnBnClickedRestBtn()
{
    KillTimer( TimerID );

    theApp.m_Robot.rest();

    SetTimer( TimerID, TimerTime, NULL );
}
